=== added file 'Percona-Server/mysql-test/suite/rpl/r/rpl_percona_bug1092593.result'
--- Percona-Server/mysql-test/suite/rpl/r/rpl_percona_bug1092593.result	1970-01-01 00:00:00 +0000
+++ Percona-Server/mysql-test/suite/rpl/r/rpl_percona_bug1092593.result	2013-05-10 09:36:09 +0000
@@ -0,0 +1,20 @@
+include/master-slave.inc
+[connection master]
+DROP TABLE IF EXISTS x;
+CREATE TABLE x (a INT) engine=InnoDB;
+INSERT INTO x VALUES (1);
+include/rpl_restart_server.inc [server_number=2 parameters: --log-slave-updates=FALSE]
+include/start_slave.inc
+INSERT INTO x VALUES (2);
+SELECT a FROM x ORDER BY a;
+a
+1
+2
+include/rpl_start_server.inc [server_number=2 parameters: --log-slave-updates=FALSE]
+include/start_slave.inc
+SELECT a FROM x ORDER BY a;
+a
+1
+2
+DROP TABLE x;
+include/rpl_end.inc

=== added file 'Percona-Server/mysql-test/suite/rpl/t/rpl_percona_bug1092593-slave.opt'
--- Percona-Server/mysql-test/suite/rpl/t/rpl_percona_bug1092593-slave.opt	1970-01-01 00:00:00 +0000
+++ Percona-Server/mysql-test/suite/rpl/t/rpl_percona_bug1092593-slave.opt	2013-05-10 09:53:32 +0000
@@ -0,0 +1,1 @@
+--innodb-recovery-update-relay-log --skip-core-file --skip-stack-trace --log-bin --log-slave-updates

=== added file 'Percona-Server/mysql-test/suite/rpl/t/rpl_percona_bug1092593.test'
--- Percona-Server/mysql-test/suite/rpl/t/rpl_percona_bug1092593.test	1970-01-01 00:00:00 +0000
+++ Percona-Server/mysql-test/suite/rpl/t/rpl_percona_bug1092593.test	2013-05-10 09:53:32 +0000
@@ -0,0 +1,81 @@
+###########################################################################
+# Bug 1092593: crash-resistant replication doesn't work when InnoDB
+#              operates with binary log disabled
+#
+# Test the slave running with --log-slave-updates first, then
+# restarting without this option, and crashing.  With the bug
+# present, crash recovery will restore binlog position that was
+# written before the restart and thus is outdated
+###########################################################################
+
+--source include/have_innodb.inc
+--source include/not_valgrind.inc
+--source include/not_crashrep.inc
+--source include/master-slave.inc
+
+--disable_query_log
+call mtr.add_suppression("InnoDB: Warning: innodb_overwrite_relay_log_info is enabled.");
+--enable_query_log
+
+connection master;
+
+# InnoDB and binlog are operating using two-phase commit protocol
+# at slave, both "prepare" and "commit" points are updated with
+# binlog coordinates
+
+--disable_warnings
+DROP TABLE IF EXISTS x;
+--enable_warnings
+
+CREATE TABLE x (a INT) engine=InnoDB;
+
+INSERT INTO x VALUES (1);
+
+sync_slave_with_master;
+
+# Restart the slave.
+# Now InnoDB is operating using one-phase commit protocol at
+# slave.  Before the fix, only the "commit" point was being
+# updated.
+--let $rpl_server_number= 2
+--let $rpl_server_parameters= --log-slave-updates=FALSE
+--source include/rpl_restart_server.inc
+--source include/start_slave.inc
+
+connection master;
+
+INSERT INTO x VALUES (2);
+
+sync_slave_with_master;
+
+SELECT a FROM x ORDER BY a;
+
+# Kill the slave to trigger binlog position recovery from
+# "prepare" point on the next startup
+-- exec echo "wait" > $MYSQLTEST_VARDIR/tmp/mysqld.2.expect
+-- shutdown_server 0
+-- source include/wait_until_disconnected.inc
+
+--let $rpl_server_number= 2
+--let $rpl_server_parameters= --log-slave-updates=FALSE
+--source include/rpl_start_server.inc
+
+# This will fail if the bug is present: the binlog coordinates
+# at "prepare" point have been last updated before the server
+# restart.  After the restart the slave was running without
+# --log-slave-updates, skipping the "prepare" point update.  Thus
+# on startup slave will read the obsolete position and fail.
+# After the fix the "prepare" point will be current.
+--source include/start_slave.inc
+
+connection master;
+
+sync_slave_with_master;
+
+SELECT a FROM x ORDER BY a;
+
+connection master;
+
+DROP TABLE x;
+
+--source include/rpl_end.inc

=== modified file 'Percona-Server/storage/innobase/trx/trx0trx.c'
--- Percona-Server/storage/innobase/trx/trx0trx.c	2013-02-26 09:00:37 +0000
+++ Percona-Server/storage/innobase/trx/trx0trx.c	2013-05-10 09:53:32 +0000
@@ -947,6 +947,18 @@
 			trx->mysql_master_log_pos,
 			TRX_SYS_COMMIT_MASTER_LOG_INFO, &mtr);
 
+		trx_sys_update_mysql_binlog_offset(
+			sys_header,
+			trx->mysql_relay_log_file_name,
+			trx->mysql_relay_log_pos,
+			TRX_SYS_MYSQL_RELAY_LOG_INFO, &mtr);
+
+		trx_sys_update_mysql_binlog_offset(
+			sys_header,
+			trx->mysql_master_log_file_name,
+			trx->mysql_master_log_pos,
+			TRX_SYS_MYSQL_MASTER_LOG_INFO, &mtr);
+
 		trx->mysql_master_log_file_name = "";
 	}
 

